


#property copyright "Copyright  2015, mony"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 DimGray
#property indicator_color2 OrangeRed
#property indicator_color3 MediumSeaGreen
#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 2
#property indicator_style1 STYLE_DOT
#property indicator_maximum 1
#property indicator_minimum 0


#define INDICATOR_NAME "xSuperTrend MTF"
#define INDICATOR_VERSION "v1.01, www.xaphod.com"


extern string Version_Info=INDICATOR_VERSION;
extern string SuperTrend_Settings="";



extern int    ATRperiod    = 300;  // ATRperiod
extern double CCIperiod= 3; // CCIperiod

extern ENUM_APPLIED_PRICE applied_price   = PRICE_TYPICAL;  // Price to use
extern int    SuperTrend_TimeFrame = 0;   // SuperTrend Timeframe
extern bool   SuperTrend_AutoTF    = true;    // Select next higher TF. If TF=M15 then H1 is selected
extern bool   alertsOn             = False;
extern bool   alertsOnCurrentBar   = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;



double gadUpBuf[];
double gadDnBuf[];
double gadSuperTrend[];
int giTimeFrame;
int giRepaintBars;


int init(){
  
  SetIndexStyle(0, DRAW_LINE);
  SetIndexBuffer(0, gadSuperTrend);
  SetIndexLabel(0, "SuperTrend");
  SetIndexStyle(1, DRAW_LINE);
  SetIndexBuffer(1, gadDnBuf);
  SetIndexLabel(1, "SuperTrend Down");
  SetIndexStyle(2, DRAW_LINE);
  SetIndexBuffer(2, gadUpBuf);
  SetIndexLabel(2, "SuperTrend Up");
  
  
  if (SuperTrend_TimeFrame==0)
    SuperTrend_TimeFrame=Period();
  if (SuperTrend_AutoTF==True)
    SuperTrend_TimeFrame=NextHigherTF(Period());
  
  
  if (SuperTrend_AutoTF==False && SuperTrend_Settings=="") {
    giRepaintBars=0;
  }
  
  else if (SuperTrend_TimeFrame!=Period()) {
    IndicatorShortName(INDICATOR_NAME+" "+TF2Str(SuperTrend_TimeFrame) +"["+ATRperiod+";"+DoubleToStr(CCIperiod,1)+"]");
    giRepaintBars=SuperTrend_TimeFrame/Period()*2+1;
  }
  
  else {
    IndicatorShortName(INDICATOR_NAME+" "+TF2Str(SuperTrend_TimeFrame) +"["+ATRperiod+";"+DoubleToStr(CCIperiod,1)+"]");
    giRepaintBars=0;
    

  return(0);
}




int deinit() {
   return (0);
}



int start() ;                      
  int ilimit, iCountedBars, i;
  double dLevel;  
  
  
  iCountedBars=IndicatorCounted(); 
 
  if(iCountedBars < 0) return (-1); 
  if(iCountedBars>0) iCountedBars--;
  ilimit=MathMax(giRepaintBars,Bars-iCountedBars);
  
  for(i=ilimit; i>=0; i--) {
    
    
   
    if (SuperTrend_TimeFrame==Period()) {
      
   
   
   
     
   
   
    if (gadSuperTrend[ilimit]==-1) CleanPoint(ilimit,gadUpBuf,gadDnBuf);  
    
  
      double cciTrendNow = iCCI(NULL, 0, CCIperiod, applied_price, i);
      if (cciTrendNow >= 0)   
      
       {
            dLine[i] = NormalizeDouble(Low[i] -  1.5*   iATR(NULL, 0, ATRperiod, i),Digits);    
               if (i<(Bars-1) && dLine[i] < dLine[i+1]) dLine[i] = dLine[i+1];
         }
         if (cciTrendNow <= 0) 
         {
            dLine[i] = NormalizeDouble(High[i] +  1.5*  iATR(NULL, 0, ATRperiod, i),Digits);
               if (i<(Bars-1) && dLine[i] > dLine[i+1]) dLine[i] = dLine[i+1];
         } 
      
   
     gadUpBuf[i] = EMPTY_VALUE;
         gadDnBuf[i] = EMPTY_VALUE;
         if (i<(Bars-1))
         {
            gadSuperTrend[i] = gadSuperTrend[i+1];
               if (dLine[i]> dLine[i+1]) gadSuperTrend[i] = 1;
               if (dLine[i]< dLine[i+1]) gadSuperTrend[i] =-1;
               if (gadSuperTrend[i] == -1) PlotPoint(i,gadUpBuf,gadDnBuf,dLine);
               if (gadSuperTrend[i] ==  1) { HistUp[i] = Low[i]; HistDn[i] = Open[i]; }
               if (gadSuperTrend[i] == -1) { HistDn[i] = High[i]; HistUp[i] = Close[i]; }
      
      
      
      
      
      
      
      
      gadUpBuf[i]=EMPTY_VALUE;
      gadDnBuf[i]=EMPTY_VALUE;
      if (Close[i]>gadSuperTrend[i] || (Close[i]==gadSuperTrend[i] && Close[i+1]>gadSuperTrend[i+1])) 
        gadUpBuf[i]=gadSuperTrend[i];
      else if (Close[i]<gadSuperTrend[i] || (Close[i]==gadSuperTrend[i] && Close[i+1]<gadSuperTrend[i+1]))  }
        gadDnBuf[i]=gadSuperTrend[i];
      
      
     
      
      
        
   
   
    else {
      gadUpBuf[i]=EMPTY_VALUE;
      gadDnBuf[i]=EMPTY_VALUE;
      gadSuperTrend[i]=iCustom(Symbol(),SuperTrend_TimeFrame,WindowExpertName(),"","",ATRperiod,
                        CCIperiod,SuperTrend_TimeFrame,False,alertsOn,alertsOnCurrentBar,alertsMessage,alertsSound,alertsEmail,0,iBarShift(Symbol(), SuperTrend_TimeFrame, Time[i]));
      gadDnBuf[i]=iCustom(Symbol(),SuperTrend_TimeFrame,WindowExpertName(),"","",ATRperiod,
                        CCIperiod,SuperTrend_TimeFrame,False,alertsOn,alertsOnCurrentBar,alertsMessage,alertsSound,alertsEmail,1,iBarShift(Symbol(), SuperTrend_TimeFrame, Time[i]));
      gadUpBuf[i]=iCustom(Symbol(),SuperTrend_TimeFrame,WindowExpertName(),"","",ATRperiod,
                        CCIperiod,SuperTrend_TimeFrame,False,alertsOn,alertsOnCurrentBar,alertsMessage,alertsSound,alertsEmail,2,iBarShift(Symbol(), SuperTrend_TimeFrame, Time[i]));                                                
      gadSuperTrend[i]=iCustom(NULL,SuperTrend.TimeFrame,"xSuperTrend","","",SuperTrend.Period,SuperTrend.Multiplier,0,iBarShift(Symbol(), SuperTrend.TimeFrame, Time[i]));
    
  if (SuperTrend_TimeFrame==Period()) manageAlerts();
  
  return(0);
}
//+------------------------------------------------------------------+


//-----------------------------------------------------------------------------
// function: TF2Str()
// Description: Convert time-frame to a string
//-----------------------------------------------------------------------------
string TF2Str(int iPeriod) {
  switch(iPeriod) {
    case PERIOD_M1: return("M1");
    case PERIOD_M5: return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1: return("H1");
    case PERIOD_H4: return("H4");
    case PERIOD_D1: return("D1");
    case PERIOD_W1: return("W1");
    case PERIOD_MN1: return("MN1");
    default: return("M"+iPeriod);
  }
}


//-----------------------------------------------------------------------------
// function: NextHigherTF()
// Description: Select the next higher time-frame. 
//              Note: M15 and M30 both select H1 as next higher TF. 
//-----------------------------------------------------------------------------
int NextHigherTF(int iPeriod) {
  if (iPeriod==0) iPeriod=Period();
  switch(iPeriod) {
    case PERIOD_M1: return(PERIOD_M5);
    case PERIOD_M5: return(PERIOD_M15);
    case PERIOD_M15: return(PERIOD_H1);
    case PERIOD_M30: return(PERIOD_H1);
    case PERIOD_H1: return(PERIOD_H4);
    case PERIOD_H4: return(PERIOD_D1);
    case PERIOD_D1: return(PERIOD_W1);
    case PERIOD_W1: return(PERIOD_MN1);
    case PERIOD_MN1: return(PERIOD_MN1);
    default: return(Period());
  }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrentBar)
           int whichBar = 0;
      else     whichBar = 1;
      if ((gadUpBuf[whichBar] != EMPTY_VALUE && gadUpBuf[whichBar+1] == EMPTY_VALUE) || (gadDnBuf[whichBar]!=EMPTY_VALUE && gadDnBuf[whichBar+1]==EMPTY_VALUE))
      {
         if (gadUpBuf[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
         if (gadDnBuf[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) 
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  TF2Str(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" super trend signal changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"super trend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   

}














//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}


void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}